

--name of game: rem psych?

DEPTHS = {
    FLOOR = -2,
    PUDDLES = 0,
    CREATURES = 2,
    BULLETS = 3.5,
    EFFECTS = 4,
    CORPSES = 6,
    ITEMS = 8,
    DOORS = 10,
    DOORS_CLOSED = -2,
    SCRATCHES = -1,
}

_W, _H = 1280,800--1000,560
 ww = _W/1000
 hh = _H/560
aspect.setGame(_W, _H)

local req = function(n)
    return require_and_sign(string.format("deadend.%s",n))
end


Room = req "room"

Stats = req "game.stats"
Level = req "game.level"
Effect = req "game.effect"
Event = req "game.event"

Entity = req "objects.entity"
Thing = req "objects.thing"
Person = req "objects.person"
Item = req "objects.item"
Setpiece = req "objects.setpiece"


Lightning = req "stuff.lightning"
req "stuff.stuff"

--math.randomseed(love.timer.getTime())

sfx_data = req("sfx_data")
media.setSource("dreamer/assets")

function getRetroDie()
    return "missile_explosion"--string.format("die%s",math.random(1,3))
end

function loadMusic2(m)
    return loadMusic(m,true)
end

loadMusic = function(m,noCancel) 
    if not noCancel or not _m_list then 
        _m_list = lume.copy(m_list)
    end
    
    if not m then
        m = _m_list[1]
        table.remove(_m_list,1)
        if #_m_list <= 0 then
            _m_list = nil
        end
    end
    
    local dat = music[m]
    media.loadMusic(dat.source, dat.loop)
    if not noCancel_nil and gmt then
        game.timer:cancel(gmt)
        gmt = nil
    end
    
    gmt = game.timer:after(dat.len+7, loadMusic2)

end



DESKTOP = love.system.getOS()~= "Android" and
love.system.getOS()~= "IOS"

if not DESKTOP then
    love.window.setFullscreen(true)
else
        toybox.getData("rem").fullscreen  = toybox.getData("rem").fullscreen or true
        love.window.setFullscreen(toybox.getData("rem").fullscreen  )
end

--media.load(sfx_data)
----
----

do
    cfont = love.graphics.newFont("c")
    font20 = love.graphics.newFont("c",H(40))
    font13 = love.graphics.newFont("c",H(20))
    font8 = love.graphics.newFont("c",H(15))
    love.graphics.setFont(font8)
 
    
    gooi.setStyle({
        bgColor = {0,0,0},--250/255,1,252/255,1},colors.blue,
        fgColor = colors.white,
        showBorder = true,
        borderColor = colors.white,
        font = font13,
        mode3d = false
    })
end

m_list = {"school","dance","groovy"}
--loadMusic()

_G.gData = {bullets={}}
_G.data = gData

local dataNames = {
    
    objects = true,
    actions = true
    --["soulp.data.tiles.lua"] = false,
}

local function importData(name, path)
    local data = name:sub(1,-5)
    
    if path then
        data = path.."/"..data
    end
    
    require(data)
end

local function loadData()
    for dir, folder in pairs(dataNames) do
        
        if folder then
            local path = string.format("%s%s","deadend/data/",dir)
            local items = love.filesystem.getDirectoryItems(path)
            gData[dir] = {}
            _G[dir] = gData[dir]
            --importData(dir..".lua", path)
            for x = 1, #items do
                importData(items[x],path)
            end
            
            for name, data in pairs(gData[dir]) do
                data._name = name
                data._id = name
            end
            
        else
        
            importData(dir)
        
        end
    end
end

loadData()

for x, i in pairs(actions) do
    i.name = i.name or x
end

local Board = toybox.Room "Board"

function Board:setup()
    
end

function Board:draw_before()
    love.graphics.draw(game:getAsset("concept2.png"))
    love.graphics.push()
    love.graphics.rotate(3.14)
    love.graphics.rectangle("line",900,300,700,200)
    love.graphics.pop()
end

game = toybox.Game("game")

function game:setup()
    self:setSource("deadend/assets/%s")
    
    
    game.set_image_filter = "nearest"
    
    level = Level:new({})
    level:gen()
    self:set_room(level.room.name)
    level.room:setData(level.firstRoom)---:checkDoors()
    
    c = Person:new({x=300,y=300,w=300,h=300})
    c.room.timer:after(2, function()
        c.gravity = 0
    end)
    
    --c.timer:every(.5, function() c.name_tag = c.x end)
    c.static = false
    c.gravity = 30
    level.room:must_draw(c)
    level.room:must_update(c)
    
    c.depth = 100
    toybox.room.player = c
end

function game:restart()
    gooi.components = {}
    local k = Level:new({})
    
    self:add_room(k, true)
    self:set_room(k.name)
end

function game:step()

    
end

function game:playAction(act, obj)
    local action = actions[act] or act
    if action.action then
        action.action(obj)
    end
end

return game