local Thing = Entity:extend("Thing")

function Thing:create(k)
    Entity.create(self, k)
    
    
    local stats = k.stats or k
    self._stats = Stats:new({
        health = getValue(stats.health or 10),
        strength = getValue(stats.strength or 2),
        accuracy = getValue(stats.accuracy or 8),
        speed = getValue(stats.speed or 1),
        agility = getValue(stats.agility or 1),
        defense = getValue(stats.defense or 3),
        flammable = getValue(stats.flammable or 0),
        exp = getValue(stats.exp or 1),
        
        confidence = getValue(stats.confidence or 0),
        analysis = getValue(stats.analysis or 0),
        bloodlust = getValue(stats.bloodlust or 0),
        morale = getValue(stats.morale or 0)
        
    }, self)
    
    --self.type = "Thing"
    
    self:ignore("Thing")--.solid = fase
    self:ignore("Setpiece")
    self:ignore("Person")
    self:ignore("Item")
    self:set_collision_type("Thing","cross")
    
    self.broken = k.broken
    self.onBreak = k.onBreak
    self.canBreak = self.broken or self.onBreak
    
    self.isThing = true
end

function Thing:getActions()
    local acts = {}
    
    for x,act in pairs(actions) do
        local continue = false
        if type(act.object) == "table" then
            for xx, ii in pairs(act.object) do
                if self[xx] and ii then
                    continue = true
                elseif self[xx] and not ii then
                    continue = false
                    break
                end
            end
        elseif act.object then
            continue = self[act.object]
        end
        
        if continue then
            acts[#acts+1] = act
        end
    end
    
    return acts
end

return Thing