

VelocityController = LGML.Controller("VelocityController")

local oi = VelocityController.__init__
function VelocityController:__init__(k, ...)
    local k = k or {}
    k.noRjoystick = true
    oi(self, k, ...)
    self.paddy.dpad.buttons = {}
    self.paddy.Ljoystick:setDigital(true)
end

function VelocityController:mousepressed(x,y)

    if DESKTOP then
        local x,y = self.room.camera:toWorldCoords( res.getMousePosition(x,y))
    
        self.Rjoystick.anglee = self.object:getAngle({x=x,y=y})

   
   end
end

function VelocityController:mousereleased(x,y)
    local x,y = self.room.camera:toWorldCoords( res.getMousePosition(x,y))
    
   -- self.Rjoystick.anglee = nil



end

function VelocityController:keypressed(s)
  
end


function VelocityController:keyreleased(s) 
    if s == "quit" then love.event.quit() end

end
local cam = {x=W()/2,y=H()/2}

function VelocityController:step(dt)
    
    local vx = self.Ljoystick:getXDir()
    local vy = self.Ljoystick:getYDir()
    
    local obj = self.object
    local sp = (40*(40/16))/1.5
    
    if obj.noControl then
        return
    end
    
    if obj.thrown then
        return
    end
    
    obj.max_v = sp*1*(obj.makxVx or 1.5)
    local maxv = obj.max_v
    
    if not obj.moving and obj.tile then
        local targ = self.room:getTile(obj.tile._x+vx, obj.tile._y+vy)
        if targ and targ~=obj.tile then
            log("!!!!!!?: "..vx..","..vy..": "..(targ._x-obj.tile._x)..","..(targ._y-obj.tile._y))
            obj:moveToTile(targ)
        end
    end
    
end

function Explode(x,y,scale,color)
    if type(x) == 'number' then
        local nt = scale or 1.2
        local exp = toybox.NewBaseObject({solid=false, static=true, w=tw*nt,h=tw*nt, x =x,y=y})
        exp.depth = DEPTHS.EFFECTS
        exp.sprite = toybox.new_sprite(exp, {
            source = "explosion",--effects/explosion",
            delay = .1,
            mode = "once",
            onAnimEnd = function()
                exp:destroy()
            end
        })
        exp.color = color or dcolors.fire
        exp:play_sound(getRetroDie())
    else
        local function ex()
            local xx = math.random(x.x, x.x+x.w)
            local xy = math.random(x.y, x.y+x.h)
            Explode(xx, xy)
        end
        
        local t = toybox.room.timer:every(.2,ex)
        
        local can = function()
            toybox.room.timer:cancel(t)
        end
        
        toybox.room.timer:after(y or math.max(x.w,x.h)/tw, can)
    end
end

local function _doSwirl(x,y,c,inc)
    Debris.spawn(x-tw/2 ,y-tw/2, getValue(c or "white"), nil, 30*(inc or 1),nil,nil,nil,nil,nil,3)
end

local function doSwirl(c,inc)
    for xx = 1,math.random(1,2) do
        _doSwirl(math.random(50,W()-50), math.random(50,H()-50), c, (inc or 1)+30)
    end
end

function Swirl(color, duration, inc)
    local tag = toybox.room.timer:every(.3, function()
        doSwirl(color, inc)
    end)
    
    toybox.room.timer:after(duration or 3, function()
        toybox.room.timer:cancel(tag)
    end)
end

function lerp(a, b, t)
    return t <.5 and a+(b-a)*t or b-(b-a)*(1-t)
end

function parabola(a, b, t)
    return lerp(a, b, 1-(t*2-1)^2)
end

function lstrike(user, obj, att, color, time)
    local nnn = 4
    local l = Lightning:new({
        x=user.x+0*user.w/nnn,
        y=user.y,
        gx=obj.offset_x+obj.x+obj.w/nnn,
        gy=obj.y+obj.offset_y+obj.h/nnn+0*tw*.5,
        thickness = 10,
        color=color or type(att) == "string" and att or "yellow"})
    
    l.depth = (user.depth or obj.depth or  DEPTHS.EFFECTS) - .1
    toybox.room:smallShake()
    obj.canMove = falsw
    obj:play_sound("zap")
    toybox.room:after(time or .3 or .7, function()
        l:destroy()
        obj.canMove = true
        if type(att) == "number" then
            obj:takeDamage(att, user)
        elseif type(att) == "function" then
            att(user, obj)
        end
        toybox.room:smallShake()
    end)    
    
end

function Party(self,t,s,type)
    self.party = s or self.party
    if self.partyColor then
        return
    end
    
    self.partyColor = lume.copy(colors.purple)
    self.partyTime = t or .5
    
    self.timer = self.timer or toybox.room.timer
    self.timer:every(self.partyTime,function()
        local col = getValue(dcolors or colors)
        self.timer:tween(self.partyTime,self.partyColor,col)
        if self.party then
            self[type or "color"] = self.partyColor
        else
            self[type or "color"] = type and {1,1,1,1} or nil
        end    
    end)
    
end

Gas = class:extend("Gas")

function Gas:__init__(kwargs)
    self.min_vx = kwargs.min_vx or kwargs.vx or 1
    self.max_vx = kwargs.max_vx or kwargs.vx or -1
    self.min_vy = kwargs.min_vy or kwargs.vy or -30--75
    self.max_vy = kwargs.max_vy or kwargs.vy or -10--75
    
    self.amount = kwargs.amount or 4
    self.on_collide = kwargs.on_collide
    
    self.room = kwargs.room or toybox.room
    
    self.color = kwargs.color
    self.colors = kwargs.colors
    
    self.x = kwargs.x or 0
    self.y = kwargs.y or 0
    self.w = kwargs.w or 8
    self.h = kwargs.h or 1
    
    self.reach = kwargs.reach or 1
    
    self.source = kwargs.source
    
    self.time = 0
    self.sprayInterval = kwargs.sprayInterval or .5
    


    self.room = toybox.room

    self.depth = DEPTHS.EFFECTS
    
    self.id = lume.uuid()
    toybox.room:store_instance(self)
    self.room:must_update(self)
    
end

function Gas:__draw()
end

local bb = function(self, i)
            if i.isDebris or not i.solid then--(i.isEntity or i.isTile) and i.solid then
                return --"cross"
            end
            return "cross"
        end

    sgetVx = function(self,vx) return math.cos(self.time_alive)*vx end
    sgetVy = function(self,vx) return math.sin(self.time_alive)*vx end
function Gas:spray() if self.creature and self.creature.isDead then return end
    local x,y = math.random(self.x,self.w+self.x), self.y--math.random(self.y,self.h+self.y)
    r = self.room--:get_room("level")--currentLevel.name)
    for xx = 1, math.random(self.amount/2,self.amount) do
        local vx = math.random(self.min_vx, self.max_vx)
        local vy = math.random(self.min_vy, self.max_vy)
        local color = getValue(self.colors) or self.color
        local d = Debris:new({noSpin=true,room=r,color=color,life=self.reach ,w=self.w,vx=vx,vy=vy})
        d.ll = self.reach
        d.source = self.source or d.source
        --d.__check_collision = bb
        d.solid=fasle
        --d.bounce = 1.1
       -- d.getVx = sgetVx
        --d.getVy = sgetVy
        d.debujg=1--destroy=function(e) error(e.maxL) end
        r:place_instance(d, x, y)
    end
end

function Gas:destroy()
    self.room.instances[self.id] = nil
    self.room:must_draw(self,true)
end

function Gas:__step(dt)
    self.time = self.time - dt
    if self.time <= 0 then
        self.time = self.sprayInterval
        self:spray()
    end
end

Text = class:extend("Text")

function Text:__init__(x,y,text,color,scale,vy,life)
    if type(x) == "table" then
        text = x.text
        y = x.y
        color = x.color
        scale = x.scale
        self.b = x.b
        life = x.life
        vy = x.vy
        x = x.x
        
    end
    
    self.x = x or 0
    self.y = y or 0
    
    self.text = text or "???"
    self.color = color
    
    self.life = life or 1
    self.room = toybox.room
    
    self.vy = vy or -70
    self.vx = 0
    self.depth = DEPTHS.EFFECTS
    
    self.dead = .3
    
    self.id = lume.uuid()
    toybox.room:store_instance(self)
    self.room:must_draw(self)
    self.room:must_update(self)
    self.scale = scale or 1
end

function Text:__step(dt)
    
    self.life = self.life-dt
    if self.life <= 0 then
        self.dead = self.dead-dt
        if self.dead <= 0 then
            self:destroy()
        end
        return
    end
    
    self.y = self.y+self.vy*dt
    self.x = self.x+self.vx*dt
end

function Text:destroy()
    self.room.instances[self.id] = nil
    self.room:must_draw(self,true)
end

function Text:__draw()
    local r,g,b,a = love.graphics.getColor()
    love.graphics.setColor(getColor(self.color or "white"))
    
    love.graphics.print(self.text, self.x, self.y,0,self.scale,self.scale)
    local ss = self.scale*2
    local n = love.graphics.getFont():getWidth(self.b or "")* ss
    local nn = love.graphics.getFont():getHeight(self.b or "")/2
    love.graphics.print(self.b or "",self.x-n,self.y-nn,0,ss,ss)
    
    love.graphics.setColor(r,g,b,a)
end
    
--media.load(sfx_data)

do
    local crt = "comic.ttf"--"cabinsketch.otf"
    cfont = love.graphics.newFont(crt)
    font20 = love.graphics.newFont(crt,H(40))
    font13 = love.graphics.newFont(crt,H(30))
    font8 = love.graphics.newFont(crt,H(20))
    love.graphics.setFont(font8)
    gooi.font = font20
    local style = {
        bgColor = {0,0,0,.5},colors.black,--{176/255,122/255,14/255},-- colors.darkbrown,
        borderColor = colors.white,
        showBorder = true,
        fgColor = colors.white,
        font = font13
    }
    


    gooi.desktopMode()
    gooi.setStyle(style)

    --self:activate_gooi()
end

local langles = {360, -360, 180, -180}
Debris = toybox.Object("Debris")

Debris.create = function(self, p)
    self.va = 300
    local s = 75--p.v or 150
    self.vx = p.vx or math.random(-s,s)
    self.vy = p.vy or math.random(-s,s)
    self.isLeaf = p.isLeaf or LEAF_DEBRIS
    self.isDrop = p.isDrop or DROP_DEBRIS
    self.isSmoke = p.isSmoke or SMOKE_DEBRIS
    local time = (self.isLeaf and 7 or self.isSmoke and 4 or self.isDrop and 6 or 5)+(self.isLeaf and 7 or self.isSmoke and 7 or 2)
    self.ll = p.life or .15*time--p.l or 1.
    self.ssource = (self.isLeaf and "setpieces/leaf" or self.isSmoke and "setpieces/smoke" or
    self.isDrop and "setpieces/drop" or p.source) --or "debris.png"
    self.sprite = p.sprite ~= false and toybox.new_sprite(self, {
        animations = {
            idle = {
                source = self.ssource or "setpieces/debris",
                delay = self.isSmoke and getValue(20,40)/100 or .15,-- self.ll/time,--.15,
                mode = "once"
            }
        }
    })
    self.color = p.color or "white"--red"
    self.w, self.h = 20/(40/150)--p.w or 10
    self.h = self.w
    self:set_box()
    self:center()
    self.solid = false
    --self.gravity = 0
    self.depth = DEPTHS.EFFECTS
    self.ll = p.lifte or .15*time--p.l or 1.2
    self.maxL = self.ll
    if self.isLeaf then
        self.angle = getValue(langles)
        self.flipX = self:getDir(self.angle)
        self.va = 0
    elseif self.isDrop then
        self.va = 0
        self.vx = self.vx*2
        self.vy = self.vy*2
        self.face_direction = 1
        self.gravity = 10
    elseif self.isSmoke then
        self.w, self.h = self.w*2, self.h*2
        self.va =0* getValue(langles)
    end
    self.w = self.w*(p.scale or 1)
    self.h = self.h*(p.scale or 1)
    
    self.getVx = p.noSpin and self.getX or function(self,vx) return math.cos(self.time_alive)*5+vx end
    self.getVy = p.noSpin and self.getY or function(self,vx) return math.sin(self.time_alive)*5+vx end
end

function Debris:update(dt)
    self.ll = self.ll - dt
    self.image_alpha = (self.ll/self.maxL)<1.5 and (self.ll/self.maxL) or 1
    if self.ll <= 0 then
        self:destroy()
    end
end

Debris.spawn = function(x,y,color,source,n,w,h,vx,vy,life,sc)
    r = game.room--:get_room("level")--currentLevel.name)
    for xx = 1, DROP_DEBRIS and 10 or SMOKE_DEBRIS and 10 or math.random(2,5) do
        local d = Debris:new({
            room=r,
            color = type(color)=="table" and type(color[1])=="string" and getValue(color)
                    or color,
            l=life or .3 ,w=w or 8,vx=vx,vy=vy,scale=sc
        })
        d.source = source or d.source
        
        r:place_instance(d, x, y)
    end
end

spawnDebris = Debris.spawn

function debrisDestroy(self)
    spawnDebris(self.x, self.y, self.debrisColor or self.color,nil,TW/5,TH/5)
end